open Syntax

type 'a env 
val empty_env : 'a env
val get_env : 'a env -> Syntax.symbol -> 'a
val add_env : 'a env -> Syntax.symbol -> 'a -> 'a env

type address
type 'a mem
val empty_mem : 'a mem
val get_mem : 'a mem -> address -> 'a
val set_mem : 'a mem -> address -> 'a -> 'a mem
val alloc_mem : 'a mem -> 'a -> address * 'a mem

type value =
  | VUnit
  | VInt of int
  | VFun of symbol * value env * expr
  | VRef of address
val eval : value env -> value mem -> expr -> value * value mem

val print_value : Format.formatter -> value * value mem -> unit
