{
  open Parser
  exception Lexing_error
}

let digit = [ '0'-'9' ]              (* les chiffres *)
let alpha = ...                      (* et les lettres *)
let blank = [' ' '\r' '\t' '\n']     (* les invisibles *)
let name  = alpha (alpha|digit|'_')* (* les identifiants *)

rule token = parse
  | blank+                 { token lexbuf }
  | '('                    { LPAR }
  | ')'                    { RPAR }
  | '!'                    { BANG }
  | '+'                    { PLUS }
  | '-'                    { MINUS }
  | '*'                    { MULT }
  | '/'                    { DIV }
  | '^'                    { CONCAT }
  | '='                    { EQUAL }
  | "->"                   { TO }
  | ":="                   { AFFECT }
  | "()"                   { UNIT }
  | ";;"                   { SEMISEMI }
  | "let"                  { LET }
  | "fun" | "function"     { FUN }
  | "in"                   { IN }
  | "ref"                  { REF }
  | digit+ as n            { INT ... }
  | name                   { NAME ... }

(* en cas d'erreur, on avance jusqu'à un éventuel ';;' *)
  | _                      { error lexbuf }

and error = parse
  | ";;"                   { raise Lexing_error }
  | _                      { error lexbuf }
