open Syntax
open Eval

let lexbuf = Lexing.from_channel stdin

let rec loop env mem =
  let _ = Format.printf "miniML#%!" in
  let sym,e = 
    try Parser.line Lexer.token lexbuf 
    with Parsing.Parse_error -> Format.printf " Lex/Parse error\n%!"; " -",TUnit
  in
  let _ = Format.printf "%a\n%!" print_expr e in 
  let env,mem = try
    let v,mem = eval env mem e in
      Format.printf "%s = %a\n%!"
	sym
	print_value (v,mem);
      add_env env sym v, mem
  with e -> Format.printf "%s\n%!" (Printexc.to_string e); env,mem
  in loop env mem

let _ = Sys.catch_break true
let _ = loop empty_env empty_mem
