%{

  open Syntax

%}

/* Remarquez comme ici on met des commentaires "à la C" et non pas avec les
(* *) de OCaml */

/* 
La définition des lexèmes correspond à un type somme du style :
  type token = INT of int | STRING of string | NAME of string 
	       | LPAR | RPAR | etc.
 */
%token <int> INT
%token <string> STRING NAME
%token LPAR RPAR LET FUN IN REF BANG TO AFFECT UNIT 
%token SEMISEMI EQUAL PLUS MINUS MULT DIV CONCAT 


/* type de "retour" du parseur: un couple (symbole défini,expression) */
%type  <Syntax.symbol * Syntax.expr> line
%start line

%%


/* liste de noms éventuellement vide */
names: 
|  { [] }
/* à faire... */
;

/* expressions ML (à structurer...) */
expr:
| UNIT                              { TUnit }
| INT                               { TInt $1 }
| NAME                              { TVar $1 }
| REF expr                          { TRef $2 }
| BANG expr                         { TDeref $2 }
| LPAR expr RPAR                    { $2 }
| expr expr                         { TApp($1,$2) }
| expr PLUS expr                    { TAdd($1,$3) }
| expr MULT expr                    { TMul($1,$3) }
| expr AFFECT expr                  { TAffect($1,$3) }
| LET NAME names EQUAL expr IN expr { ... }
| FUN NAME names TO expr            { ... }
;


/* point d'entrée final */
line: 
  /*  "2+3;;" */
| expr SEMISEMI                      { " -", $1 }
  /*  "let f x = x+3;;"   (devient "let f x = x+3 in f") */
| LET NAME names EQUAL expr SEMISEMI { $2, ... }
;			      

